diff -NurpP --minimal linux-3.0/arch/ia64/include/asm/gpio.h torvalds-linux-v3.1-rc10/arch/ia64/include/asm/gpio.h
--- linux-3.0/arch/ia64/include/asm/gpio.h	1970-01-01 00:00:00.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/include/asm/gpio.h	2011-10-18 04:06:23.000000000 +0000
@@ -0,0 +1,55 @@
+/*
+ * Generic GPIO API implementation for IA-64.
+ *
+ * A stright copy of that for PowerPC which was:
+ *
+ * Copyright (c) 2007-2008  MontaVista Software, Inc.
+ *
+ * Author: Anton Vorontsov <avorontsov@ru.mvista.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#ifndef _ASM_IA64_GPIO_H
+#define _ASM_IA64_GPIO_H
+
+#include <linux/errno.h>
+#include <asm-generic/gpio.h>
+
+#ifdef CONFIG_GPIOLIB
+
+/*
+ * We don't (yet) implement inlined/rapid versions for on-chip gpios.
+ * Just call gpiolib.
+ */
+static inline int gpio_get_value(unsigned int gpio)
+{
+	return __gpio_get_value(gpio);
+}
+
+static inline void gpio_set_value(unsigned int gpio, int value)
+{
+	__gpio_set_value(gpio, value);
+}
+
+static inline int gpio_cansleep(unsigned int gpio)
+{
+	return __gpio_cansleep(gpio);
+}
+
+static inline int gpio_to_irq(unsigned int gpio)
+{
+	return __gpio_to_irq(gpio);
+}
+
+static inline int irq_to_gpio(unsigned int irq)
+{
+	return -EINVAL;
+}
+
+#endif /* CONFIG_GPIOLIB */
+
+#endif /* _ASM_IA64_GPIO_H */
diff -NurpP --minimal linux-3.0/arch/ia64/include/asm/paravirt.h torvalds-linux-v3.1-rc10/arch/ia64/include/asm/paravirt.h
--- linux-3.0/arch/ia64/include/asm/paravirt.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/include/asm/paravirt.h	2011-10-18 04:06:23.000000000 +0000
@@ -281,6 +281,10 @@ paravirt_init_missing_ticks_accounting(i
 		pv_time_ops.init_missing_ticks_accounting(cpu);
 }
 
+struct jump_label_key;
+extern struct jump_label_key paravirt_steal_enabled;
+extern struct jump_label_key paravirt_steal_rq_enabled;
+
 static inline int
 paravirt_do_steal_accounting(unsigned long *new_itm)
 {
diff -NurpP --minimal linux-3.0/arch/ia64/include/asm/processor.h torvalds-linux-v3.1-rc10/arch/ia64/include/asm/processor.h
--- linux-3.0/arch/ia64/include/asm/processor.h	2011-04-03 18:50:22.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/include/asm/processor.h	2011-10-18 04:06:23.000000000 +0000
@@ -75,7 +75,7 @@
 #include <asm/percpu.h>
 #include <asm/rse.h>
 #include <asm/unwind.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #ifdef CONFIG_NUMA
 #include <asm/nodedata.h>
 #endif
diff -NurpP --minimal linux-3.0/arch/ia64/include/asm/ptrace.h torvalds-linux-v3.1-rc10/arch/ia64/include/asm/ptrace.h
--- linux-3.0/arch/ia64/include/asm/ptrace.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/include/asm/ptrace.h	2011-10-18 04:06:23.000000000 +0000
@@ -286,7 +286,6 @@ static inline unsigned long user_stack_p
   struct task_struct;			/* forward decl */
   struct unw_frame_info;		/* forward decl */
 
-  extern void show_regs (struct pt_regs *);
   extern void ia64_do_show_stack (struct unw_frame_info *, void *);
   extern unsigned long ia64_get_user_rbs_end (struct task_struct *, struct pt_regs *,
 					      unsigned long *);
diff -NurpP --minimal linux-3.0/arch/ia64/include/asm/sn/tioce.h torvalds-linux-v3.1-rc10/arch/ia64/include/asm/sn/tioce.h
--- linux-3.0/arch/ia64/include/asm/sn/tioce.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/include/asm/sn/tioce.h	2011-10-18 04:06:23.000000000 +0000
@@ -467,7 +467,7 @@ typedef volatile struct tioce {
 #define CE_LSI_GB_CFG1_RXL0S_THS_SHFT	0
 #define CE_LSI_GB_CFG1_RXL0S_THS_MASK	(0xffULL << 0)
 #define CE_LSI_GB_CFG1_RXL0S_SMP_SHFT	8
-#define CE_LSI_GB_CFG1_RXL0S_SMP_MASK	(0xfULL << 8);
+#define CE_LSI_GB_CFG1_RXL0S_SMP_MASK	(0xfULL << 8)
 #define CE_LSI_GB_CFG1_RXL0S_ADJ_SHFT	12
 #define CE_LSI_GB_CFG1_RXL0S_ADJ_MASK	(0x7ULL << 12)
 #define CE_LSI_GB_CFG1_RXL0S_FLT_SHFT	15
diff -NurpP --minimal linux-3.0/arch/ia64/include/asm/spinlock.h torvalds-linux-v3.1-rc10/arch/ia64/include/asm/spinlock.h
--- linux-3.0/arch/ia64/include/asm/spinlock.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/include/asm/spinlock.h	2011-10-18 04:06:23.000000000 +0000
@@ -13,7 +13,7 @@
 #include <linux/kernel.h>
 #include <linux/bitops.h>
 
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/intrinsics.h>
 #include <asm/system.h>
 
diff -NurpP --minimal linux-3.0/arch/ia64/kernel/cyclone.c torvalds-linux-v3.1-rc10/arch/ia64/kernel/cyclone.c
--- linux-3.0/arch/ia64/kernel/cyclone.c	2011-08-29 03:03:57.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/kernel/cyclone.c	2011-10-18 04:06:23.000000000 +0000
@@ -115,7 +115,7 @@ int __init init_cyclone_clock(void)
 	}
 	/* initialize last tick */
 	cyclone_mc = cyclone_timer;
-	clocksource_cyclone.fsys_mmio = cyclone_timer;
+	clocksource_cyclone.archdata.fsys_mmio = cyclone_timer;
 	clocksource_register_hz(&clocksource_cyclone, CYCLONE_TIMER_FREQ);
 
 	return 0;
diff -NurpP --minimal linux-3.0/arch/ia64/kernel/efi.c torvalds-linux-v3.1-rc10/arch/ia64/kernel/efi.c
--- linux-3.0/arch/ia64/kernel/efi.c	2011-06-22 15:07:47.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/kernel/efi.c	2011-10-18 04:06:23.000000000 +0000
@@ -156,7 +156,7 @@ prefix##_get_next_variable (unsigned lon
 #define STUB_SET_VARIABLE(prefix, adjust_arg)				       \
 static efi_status_t							       \
 prefix##_set_variable (efi_char16_t *name, efi_guid_t *vendor,		       \
-		       unsigned long attr, unsigned long data_size,	       \
+		       u32 attr, unsigned long data_size,		       \
 		       void *data)					       \
 {									       \
 	struct ia64_fpreg fr[6];					       \
diff -NurpP --minimal linux-3.0/arch/ia64/kernel/entry.S torvalds-linux-v3.1-rc10/arch/ia64/kernel/entry.S
--- linux-3.0/arch/ia64/kernel/entry.S	2011-08-29 03:03:57.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/kernel/entry.S	2011-10-18 04:06:23.000000000 +0000
@@ -1614,7 +1614,7 @@ sys_call_table:
 	data8 sys_sched_get_priority_min
 	data8 sys_sched_rr_get_interval
 	data8 sys_nanosleep
-	data8 sys_nfsservctl
+	data8 sys_ni_syscall			// old nfsservctl
 	data8 sys_prctl				// 1170
 	data8 sys_getpagesize
 	data8 sys_mmap2
diff -NurpP --minimal linux-3.0/arch/ia64/kernel/module.c torvalds-linux-v3.1-rc10/arch/ia64/kernel/module.c
--- linux-3.0/arch/ia64/kernel/module.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/kernel/module.c	2011-10-18 04:06:23.000000000 +0000
@@ -304,14 +304,6 @@ plt_target (struct plt_entry *plt)
 
 #endif /* !USE_BRL */
 
-void *
-module_alloc (unsigned long size)
-{
-	if (!size)
-		return NULL;
-	return vmalloc(size);
-}
-
 void
 module_free (struct module *mod, void *module_region)
 {
@@ -853,14 +845,6 @@ apply_relocate_add (Elf64_Shdr *sechdrs,
 	return 0;
 }
 
-int
-apply_relocate (Elf64_Shdr *sechdrs, const char *strtab, unsigned int symindex,
-		unsigned int relsec, struct module *mod)
-{
-	printk(KERN_ERR "module %s: REL relocs in section %u unsupported\n", mod->name, relsec);
-	return -ENOEXEC;
-}
-
 /*
  * Modules contain a single unwind table which covers both the core and the init text
  * sections but since the two are not contiguous, we need to split this table up such that
diff -NurpP --minimal linux-3.0/arch/ia64/kernel/paravirt.c torvalds-linux-v3.1-rc10/arch/ia64/kernel/paravirt.c
--- linux-3.0/arch/ia64/kernel/paravirt.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/kernel/paravirt.c	2011-10-18 04:06:23.000000000 +0000
@@ -634,6 +634,8 @@ struct pv_irq_ops pv_irq_ops = {
  * pv_time_ops
  * time operations
  */
+struct jump_label_key paravirt_steal_enabled;
+struct jump_label_key paravirt_steal_rq_enabled;
 
 static int
 ia64_native_do_steal_accounting(unsigned long *new_itm)
diff -NurpP --minimal linux-3.0/arch/ia64/kernel/smp.c torvalds-linux-v3.1-rc10/arch/ia64/kernel/smp.c
--- linux-3.0/arch/ia64/kernel/smp.c	2011-04-03 18:50:22.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/kernel/smp.c	2011-10-18 04:06:23.000000000 +0000
@@ -32,7 +32,7 @@
 #include <linux/bitops.h>
 #include <linux/kexec.h>
 
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/current.h>
 #include <asm/delay.h>
 #include <asm/machvec.h>
diff -NurpP --minimal linux-3.0/arch/ia64/kernel/smpboot.c torvalds-linux-v3.1-rc10/arch/ia64/kernel/smpboot.c
--- linux-3.0/arch/ia64/kernel/smpboot.c	2011-06-22 15:07:47.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/kernel/smpboot.c	2011-10-18 04:06:23.000000000 +0000
@@ -40,7 +40,7 @@
 #include <linux/percpu.h>
 #include <linux/bitops.h>
 
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/cache.h>
 #include <asm/current.h>
 #include <asm/delay.h>
diff -NurpP --minimal linux-3.0/arch/ia64/kernel/time.c torvalds-linux-v3.1-rc10/arch/ia64/kernel/time.c
--- linux-3.0/arch/ia64/kernel/time.c	2011-08-29 03:03:57.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/kernel/time.c	2011-10-18 04:06:23.000000000 +0000
@@ -468,7 +468,7 @@ void update_vsyscall(struct timespec *wa
         fsyscall_gtod_data.clk_mask = c->mask;
         fsyscall_gtod_data.clk_mult = mult;
         fsyscall_gtod_data.clk_shift = c->shift;
-        fsyscall_gtod_data.clk_fsys_mmio = c->fsys_mmio;
+        fsyscall_gtod_data.clk_fsys_mmio = c->archdata.fsys_mmio;
         fsyscall_gtod_data.clk_cycle_last = c->cycle_last;
 
 	/* copy kernel time structures */
diff -NurpP --minimal linux-3.0/arch/ia64/kernel/uncached.c torvalds-linux-v3.1-rc10/arch/ia64/kernel/uncached.c
--- linux-3.0/arch/ia64/kernel/uncached.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/kernel/uncached.c	2011-10-18 04:06:23.000000000 +0000
@@ -25,7 +25,7 @@
 #include <asm/pal.h>
 #include <asm/system.h>
 #include <asm/pgtable.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/tlbflush.h>
 #include <asm/sn/arch.h>
 
diff -NurpP --minimal linux-3.0/arch/ia64/kvm/Kconfig torvalds-linux-v3.1-rc10/arch/ia64/kvm/Kconfig
--- linux-3.0/arch/ia64/kvm/Kconfig	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/kvm/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -49,6 +49,5 @@ config KVM_INTEL
 	  extensions.
 
 source drivers/vhost/Kconfig
-source drivers/virtio/Kconfig
 
 endif # VIRTUALIZATION
diff -NurpP --minimal linux-3.0/arch/ia64/sn/kernel/irq.c torvalds-linux-v3.1-rc10/arch/ia64/sn/kernel/irq.c
--- linux-3.0/arch/ia64/sn/kernel/irq.c	2011-06-22 15:07:47.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/sn/kernel/irq.c	2011-10-18 04:06:23.000000000 +0000
@@ -112,8 +112,6 @@ static void sn_ack_irq(struct irq_data *
 	irq_move_irq(data);
 }
 
-static void sn_irq_info_free(struct rcu_head *head);
-
 struct sn_irq_info *sn_retarget_vector(struct sn_irq_info *sn_irq_info,
 				       nasid_t nasid, int slice)
 {
@@ -177,7 +175,7 @@ struct sn_irq_info *sn_retarget_vector(s
 	spin_lock(&sn_irq_info_lock);
 	list_replace_rcu(&sn_irq_info->list, &new_irq_info->list);
 	spin_unlock(&sn_irq_info_lock);
-	call_rcu(&sn_irq_info->rcu, sn_irq_info_free);
+	kfree_rcu(sn_irq_info, rcu);
 
 
 finish_up:
@@ -338,14 +336,6 @@ static void unregister_intr_pda(struct s
 	rcu_read_unlock();
 }
 
-static void sn_irq_info_free(struct rcu_head *head)
-{
-	struct sn_irq_info *sn_irq_info;
-
-	sn_irq_info = container_of(head, struct sn_irq_info, rcu);
-	kfree(sn_irq_info);
-}
-
 void sn_irq_fixup(struct pci_dev *pci_dev, struct sn_irq_info *sn_irq_info)
 {
 	nasid_t nasid = sn_irq_info->irq_nasid;
@@ -399,7 +389,7 @@ void sn_irq_unfixup(struct pci_dev *pci_
 	spin_unlock(&sn_irq_info_lock);
 	if (list_empty(sn_irq_lh[sn_irq_info->irq_irq]))
 		free_irq_vector(sn_irq_info->irq_irq);
-	call_rcu(&sn_irq_info->rcu, sn_irq_info_free);
+	kfree_rcu(sn_irq_info, rcu);
 	pci_dev_put(pci_dev);
 
 }
diff -NurpP --minimal linux-3.0/arch/ia64/sn/kernel/sn2/timer.c torvalds-linux-v3.1-rc10/arch/ia64/sn/kernel/sn2/timer.c
--- linux-3.0/arch/ia64/sn/kernel/sn2/timer.c	2011-08-29 03:03:58.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/sn/kernel/sn2/timer.c	2011-10-18 04:06:23.000000000 +0000
@@ -54,7 +54,7 @@ ia64_sn_udelay (unsigned long usecs)
 
 void __init sn_timer_init(void)
 {
-	clocksource_sn2.fsys_mmio = RTC_COUNTER_ADDR;
+	clocksource_sn2.archdata.fsys_mmio = RTC_COUNTER_ADDR;
 	clocksource_register_hz(&clocksource_sn2, sn_rtc_cycles_per_second);
 
 	ia64_udelay = &ia64_sn_udelay;
diff -NurpP --minimal linux-3.0/arch/m32r/Kconfig torvalds-linux-v3.1-rc10/arch/m32r/Kconfig
--- linux-3.0/arch/m32r/Kconfig	2011-08-29 03:03:58.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m32r/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -268,17 +268,7 @@ config SCHED_OMIT_FRAME_POINTER
         bool
         default y
 
-config PREEMPT
-	bool "Preemptible Kernel"
-	help
-	  This option reduces the latency of the kernel when reacting to
-	  real-time or interactive events by allowing a low priority process to
-	  be preempted even if it is in kernel mode executing a system call.
-	  This allows applications to run more reliably even when the system is
-	  under load.
-
-	  Say Y here if you are building a kernel for a desktop, embedded
-	  or real-time system.  Say N if you are unsure.
+source "kernel/Kconfig.preempt"
 
 config SMP
 	bool "Symmetric multi-processing support"
diff -NurpP --minimal linux-3.0/arch/m32r/include/asm/atomic.h torvalds-linux-v3.1-rc10/arch/m32r/include/asm/atomic.h
--- linux-3.0/arch/m32r/include/asm/atomic.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m32r/include/asm/atomic.h	2011-10-18 04:06:23.000000000 +0000
@@ -239,15 +239,15 @@ static __inline__ int atomic_dec_return(
 #define atomic_xchg(v, new) (xchg(&((v)->counter), new))
 
 /**
- * atomic_add_unless - add unless the number is a given value
+ * __atomic_add_unless - add unless the number is a given value
  * @v: pointer of type atomic_t
  * @a: the amount to add to v...
  * @u: ...unless v is equal to u.
  *
  * Atomically adds @a to @v, so long as it was not @u.
- * Returns non-zero if @v was not @u, and zero otherwise.
+ * Returns the old value of @v.
  */
-static __inline__ int atomic_add_unless(atomic_t *v, int a, int u)
+static __inline__ int __atomic_add_unless(atomic_t *v, int a, int u)
 {
 	int c, old;
 	c = atomic_read(v);
@@ -259,10 +259,9 @@ static __inline__ int atomic_add_unless(
 			break;
 		c = old;
 	}
-	return c != (u);
+	return c;
 }
 
-#define atomic_inc_not_zero(v) atomic_add_unless((v), 1, 0)
 
 static __inline__ void atomic_clear_mask(unsigned long  mask, atomic_t *addr)
 {
@@ -314,5 +313,4 @@ static __inline__ void atomic_set_mask(u
 #define smp_mb__before_atomic_inc()	barrier()
 #define smp_mb__after_atomic_inc()	barrier()
 
-#include <asm-generic/atomic-long.h>
 #endif	/* _ASM_M32R_ATOMIC_H */
diff -NurpP --minimal linux-3.0/arch/m32r/include/asm/delay.h torvalds-linux-v3.1-rc10/arch/m32r/include/asm/delay.h
--- linux-3.0/arch/m32r/include/asm/delay.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m32r/include/asm/delay.h	2011-10-18 04:06:23.000000000 +0000
@@ -1,26 +1 @@
-#ifndef _ASM_M32R_DELAY_H
-#define _ASM_M32R_DELAY_H
-
-/*
- * Copyright (C) 1993 Linus Torvalds
- *
- * Delay routines calling functions in arch/m32r/lib/delay.c
- */
-
-extern void __bad_udelay(void);
-extern void __bad_ndelay(void);
-
-extern void __udelay(unsigned long usecs);
-extern void __ndelay(unsigned long nsecs);
-extern void __const_udelay(unsigned long xloops);
-extern void __delay(unsigned long loops);
-
-#define udelay(n) (__builtin_constant_p(n) ? \
-	((n) > 20000 ? __bad_udelay() : __const_udelay((n) * 0x10c7ul)) : \
-	__udelay(n))
-
-#define ndelay(n) (__builtin_constant_p(n) ? \
-	((n) > 20000 ? __bad_ndelay() : __const_udelay((n) * 5ul)) : \
-	__ndelay(n))
-
-#endif /* _ASM_M32R_DELAY_H */
+#include <asm-generic/delay.h>
diff -NurpP --minimal linux-3.0/arch/m32r/include/asm/mmu_context.h torvalds-linux-v3.1-rc10/arch/m32r/include/asm/mmu_context.h
--- linux-3.0/arch/m32r/include/asm/mmu_context.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m32r/include/asm/mmu_context.h	2011-10-18 04:06:23.000000000 +0000
@@ -11,7 +11,7 @@
 
 #ifndef __ASSEMBLY__
 
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/pgalloc.h>
 #include <asm/mmu.h>
 #include <asm/tlbflush.h>
diff -NurpP --minimal linux-3.0/arch/m32r/include/asm/processor.h torvalds-linux-v3.1-rc10/arch/m32r/include/asm/processor.h
--- linux-3.0/arch/m32r/include/asm/processor.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m32r/include/asm/processor.h	2011-10-18 04:06:23.000000000 +0000
@@ -106,7 +106,6 @@ struct thread_struct {
 
 #define start_thread(regs, new_pc, new_spu) 				\
 	do {								\
-		set_fs(USER_DS); 					\
 		regs->psw = (regs->psw | USERPS_BPSW) & 0x0000FFFFUL;	\
 		regs->bpc = new_pc;					\
 		regs->spu = new_spu;					\
diff -NurpP --minimal linux-3.0/arch/m32r/include/asm/ptrace.h torvalds-linux-v3.1-rc10/arch/m32r/include/asm/ptrace.h
--- linux-3.0/arch/m32r/include/asm/ptrace.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m32r/include/asm/ptrace.h	2011-10-18 04:06:23.000000000 +0000
@@ -138,8 +138,6 @@ extern void init_debug_traps(struct task
 #define instruction_pointer(regs) ((regs)->bpc)
 #define profile_pc(regs) instruction_pointer(regs)
 
-extern void show_regs(struct pt_regs *);
-
 extern void withdraw_debug_trap(struct pt_regs *regs);
 
 #define task_pt_regs(task) \
diff -NurpP --minimal linux-3.0/arch/m32r/include/asm/spinlock.h torvalds-linux-v3.1-rc10/arch/m32r/include/asm/spinlock.h
--- linux-3.0/arch/m32r/include/asm/spinlock.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m32r/include/asm/spinlock.h	2011-10-18 04:06:23.000000000 +0000
@@ -10,7 +10,7 @@
  */
 
 #include <linux/compiler.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/page.h>
 
 /*
diff -NurpP --minimal linux-3.0/arch/m32r/kernel/module.c torvalds-linux-v3.1-rc10/arch/m32r/kernel/module.c
--- linux-3.0/arch/m32r/kernel/module.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m32r/kernel/module.c	2011-10-18 04:06:23.000000000 +0000
@@ -28,33 +28,6 @@
 #define DEBUGP(fmt...)
 #endif
 
-void *module_alloc(unsigned long size)
-{
-	if (size == 0)
-		return NULL;
-#ifdef CONFIG_MMU
-	return vmalloc_exec(size);
-#else
-	return vmalloc(size);
-#endif
-}
-
-
-/* Free memory returned from module_alloc */
-void module_free(struct module *mod, void *module_region)
-{
-	vfree(module_region);
-}
-
-/* We don't need anything special. */
-int module_frob_arch_sections(Elf_Ehdr *hdr,
-			      Elf_Shdr *sechdrs,
-			      char *secstrings,
-			      struct module *mod)
-{
-	return 0;
-}
-
 #define COPY_UNALIGNED_WORD(sw, tw, align) \
 { \
 	void *__s = &(sw), *__t = &(tw); \
@@ -243,14 +216,3 @@ int apply_relocate(Elf32_Shdr *sechdrs,
 	return 0;
 
 }
-
-int module_finalize(const Elf_Ehdr *hdr,
-		    const Elf_Shdr *sechdrs,
-		    struct module *me)
-{
-	return 0;
-}
-
-void module_arch_cleanup(struct module *mod)
-{
-}
diff -NurpP --minimal linux-3.0/arch/m32r/kernel/smp.c torvalds-linux-v3.1-rc10/arch/m32r/kernel/smp.c
--- linux-3.0/arch/m32r/kernel/smp.c	2011-08-29 03:03:58.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m32r/kernel/smp.c	2011-10-18 04:06:23.000000000 +0000
@@ -26,7 +26,7 @@
 
 #include <asm/cacheflush.h>
 #include <asm/pgalloc.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/io.h>
 #include <asm/mmu_context.h>
 #include <asm/m32r.h>
diff -NurpP --minimal linux-3.0/arch/m32r/kernel/syscall_table.S torvalds-linux-v3.1-rc10/arch/m32r/kernel/syscall_table.S
--- linux-3.0/arch/m32r/kernel/syscall_table.S	2011-08-29 03:03:58.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m32r/kernel/syscall_table.S	2011-10-18 04:06:23.000000000 +0000
@@ -168,7 +168,7 @@ ENTRY(sys_call_table)
 	.long sys_tas			/* vm86 syscall holder */
 	.long sys_ni_syscall		/* query_module syscall holder */
 	.long sys_poll
-	.long sys_nfsservctl
+	.long sys_ni_syscall		/* was nfsservctl */
 	.long sys_setresgid		/* 170 */
 	.long sys_getresgid
 	.long sys_prctl
diff -NurpP --minimal linux-3.0/arch/m32r/kernel/traps.c torvalds-linux-v3.1-rc10/arch/m32r/kernel/traps.c
--- linux-3.0/arch/m32r/kernel/traps.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m32r/kernel/traps.c	2011-10-18 04:06:23.000000000 +0000
@@ -21,7 +21,7 @@
 #include <asm/system.h>
 #include <asm/uaccess.h>
 #include <asm/io.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 
 #include <asm/smp.h>
 
diff -NurpP --minimal linux-3.0/arch/m68k/Kconfig torvalds-linux-v3.1-rc10/arch/m68k/Kconfig
--- linux-3.0/arch/m68k/Kconfig	2011-08-29 03:03:58.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m68k/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -6,6 +6,7 @@ config M68K
 	select GENERIC_ATOMIC64 if MMU
 	select HAVE_GENERIC_HARDIRQS if !MMU
 	select GENERIC_IRQ_SHOW if !MMU
+	select ARCH_HAVE_NMI_SAFE_CMPXCHG if RMW_INSNS
 
 config RWSEM_GENERIC_SPINLOCK
 	bool
@@ -41,6 +42,10 @@ config NO_DMA
 config ZONE_DMA
 	bool
 	default y
+
+config CPU_HAS_NO_BITFIELDS
+	bool
+
 config HZ
 	int
 	default 1000 if CLEOPATRA
diff -NurpP --minimal linux-3.0/arch/m68k/Kconfig.mmu torvalds-linux-v3.1-rc10/arch/m68k/Kconfig.mmu
--- linux-3.0/arch/m68k/Kconfig.mmu	2011-06-22 15:07:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m68k/Kconfig.mmu	2011-10-18 04:06:23.000000000 +0000
@@ -372,12 +372,6 @@ config AMIGA_PCMCIA
 	  Include support in the kernel for pcmcia on Amiga 1200 and Amiga
 	  600. If you intend to use pcmcia cards say Y; otherwise say N.
 
-config STRAM_PROC
-	bool "ST-RAM statistics in /proc"
-	depends on ATARI
-	help
-	  Say Y here to report ST-RAM usage statistics in /proc/stram.
-
 config HEARTBEAT
 	bool "Use power LED as a heartbeat" if AMIGA || APOLLO || ATARI || MAC ||Q40
 	default y if !AMIGA && !APOLLO && !ATARI && !MAC && !Q40 && HP300
diff -NurpP --minimal linux-3.0/arch/m68k/Kconfig.nommu torvalds-linux-v3.1-rc10/arch/m68k/Kconfig.nommu
--- linux-3.0/arch/m68k/Kconfig.nommu	2011-08-29 03:03:58.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m68k/Kconfig.nommu	2011-10-18 04:06:23.000000000 +0000
@@ -16,6 +16,7 @@ config GENERIC_CLOCKEVENTS
 
 config M68000
 	bool
+	select CPU_HAS_NO_BITFIELDS
 	help
 	  The Freescale (was Motorola) 68000 CPU is the first generation of
 	  the well known M68K family of processors. The CPU core as well as
@@ -25,6 +26,7 @@ config M68000
 
 config MCPU32
 	bool
+	select CPU_HAS_NO_BITFIELDS
 	help
 	  The Freescale (was then Motorola) CPU32 is a CPU core that is
 	  based on the 68020 processor. For the most part it is used in
@@ -34,6 +36,7 @@ config COLDFIRE
 	bool
 	select GENERIC_GPIO
 	select ARCH_REQUIRE_GPIOLIB
+	select CPU_HAS_NO_BITFIELDS
 	help
 	  The Freescale ColdFire family of processors is a modern derivitive
 	  of the 68000 processor family. They are mainly targeted at embedded
diff -NurpP --minimal linux-3.0/arch/m68k/Makefile_no torvalds-linux-v3.1-rc10/arch/m68k/Makefile_no
--- linux-3.0/arch/m68k/Makefile_no	2011-06-22 15:07:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m68k/Makefile_no	2011-10-18 04:06:23.000000000 +0000
@@ -13,7 +13,7 @@ platform-$(CONFIG_M68EZ328)	:= 68EZ328
 platform-$(CONFIG_M68VZ328)	:= 68VZ328
 platform-$(CONFIG_M68360)	:= 68360
 platform-$(CONFIG_M5206)	:= 5206
-platform-$(CONFIG_M5206e)	:= 5206e
+platform-$(CONFIG_M5206e)	:= 5206
 platform-$(CONFIG_M520x)	:= 520x
 platform-$(CONFIG_M523x)	:= 523x
 platform-$(CONFIG_M5249)	:= 5249
diff -NurpP --minimal linux-3.0/arch/m68k/amiga/chipram.c torvalds-linux-v3.1-rc10/arch/m68k/amiga/chipram.c
--- linux-3.0/arch/m68k/amiga/chipram.c	2011-06-22 15:07:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/m68k/amiga/chipram.c	2011-10-18 04:06:23.000000000 +0000
@@ -16,6 +16,7 @@
 #include <linux/string.h>
 #include <linux/module.h>
 
+#include <asm/atomic.h>
 #include <asm/page.h>
 #include <asm/amigahw.h>
 
@@ -23,111 +24,100 @@ unsigned long amiga_chip_size;
 EXPORT_SYMBOL(amiga_chip_size);
 
 static struct resource chipram_res = {
-    .name = "Chip RAM", .start = CHIP_PHYSADDR
+	.name = "Chip RAM", .start = CHIP_PHYSADDR
 };
-static unsigned long chipavail;
+static atomic_t chipavail;
 
 
 void __init amiga_chip_init(void)
 {
-    if (!AMIGAHW_PRESENT(CHIP_RAM))
-	return;
+	if (!AMIGAHW_PRESENT(CHIP_RAM))
+		return;
 
-    chipram_res.end = amiga_chip_size-1;
-    request_resource(&iomem_resource, &chipram_res);
+	chipram_res.end = CHIP_PHYSADDR + amiga_chip_size - 1;
+	request_resource(&iomem_resource, &chipram_res);
 
-    chipavail = amiga_chip_size;
+	atomic_set(&chipavail, amiga_chip_size);
 }
 
 
 void *amiga_chip_alloc(unsigned long size, const char *name)
 {
-    struct resource *res;
+	struct resource *res;
+	void *p;
 
-    /* round up */
-    size = PAGE_ALIGN(size);
+	res = kzalloc(sizeof(struct resource), GFP_KERNEL);
+	if (!res)
+		return NULL;
 
-#ifdef DEBUG
-    printk("amiga_chip_alloc: allocate %ld bytes\n", size);
-#endif
-    res = kzalloc(sizeof(struct resource), GFP_KERNEL);
-    if (!res)
-	return NULL;
-    res->name = name;
+	res->name = name;
+	p = amiga_chip_alloc_res(size, res);
+	if (!p) {
+		kfree(res);
+		return NULL;
+	}
 
-    if (allocate_resource(&chipram_res, res, size, 0, UINT_MAX, PAGE_SIZE, NULL, NULL) < 0) {
-	kfree(res);
-	return NULL;
-    }
-    chipavail -= size;
-#ifdef DEBUG
-    printk("amiga_chip_alloc: returning %lx\n", res->start);
-#endif
-    return (void *)ZTWO_VADDR(res->start);
+	return p;
 }
 EXPORT_SYMBOL(amiga_chip_alloc);
 
 
-    /*
-     *  Warning:
-     *  amiga_chip_alloc_res is meant only for drivers that need to allocate
-     *  Chip RAM before kmalloc() is functional. As a consequence, those
-     *  drivers must not free that Chip RAM afterwards.
-     */
+	/*
+	 *  Warning:
+	 *  amiga_chip_alloc_res is meant only for drivers that need to
+	 *  allocate Chip RAM before kmalloc() is functional. As a consequence,
+	 *  those drivers must not free that Chip RAM afterwards.
+	 */
 
-void * __init amiga_chip_alloc_res(unsigned long size, struct resource *res)
+void *amiga_chip_alloc_res(unsigned long size, struct resource *res)
 {
-    unsigned long start;
+	int error;
 
-    /* round up */
-    size = PAGE_ALIGN(size);
-    /* dmesg into chipmem prefers memory at the safe end */
-    start = CHIP_PHYSADDR + chipavail - size;
+	/* round up */
+	size = PAGE_ALIGN(size);
 
-#ifdef DEBUG
-    printk("amiga_chip_alloc_res: allocate %ld bytes\n", size);
-#endif
-    if (allocate_resource(&chipram_res, res, size, start, UINT_MAX, PAGE_SIZE, NULL, NULL) < 0) {
-	printk("amiga_chip_alloc_res: first alloc failed!\n");
-	if (allocate_resource(&chipram_res, res, size, 0, UINT_MAX, PAGE_SIZE, NULL, NULL) < 0)
-	    return NULL;
-    }
-    chipavail -= size;
-#ifdef DEBUG
-    printk("amiga_chip_alloc_res: returning %lx\n", res->start);
-#endif
-    return (void *)ZTWO_VADDR(res->start);
+	pr_debug("amiga_chip_alloc_res: allocate %lu bytes\n", size);
+	error = allocate_resource(&chipram_res, res, size, 0, UINT_MAX,
+				  PAGE_SIZE, NULL, NULL);
+	if (error < 0) {
+		pr_err("amiga_chip_alloc_res: allocate_resource() failed %d!\n",
+		       error);
+		return NULL;
+	}
+
+	atomic_sub(size, &chipavail);
+	pr_debug("amiga_chip_alloc_res: returning %pR\n", res);
+	return (void *)ZTWO_VADDR(res->start);
 }
 
 void amiga_chip_free(void *ptr)
 {
-    unsigned long start = ZTWO_PADDR(ptr);
-    struct resource **p, *res;
-    unsigned long size;
+	unsigned long start = ZTWO_PADDR(ptr);
+	struct resource *res;
+	unsigned long size;
 
-    for (p = &chipram_res.child; (res = *p); p = &res->sibling) {
-	if (res->start != start)
-	    continue;
-	*p = res->sibling;
-	size = res->end-start;
-#ifdef DEBUG
-	printk("amiga_chip_free: free %ld bytes at %p\n", size, ptr);
-#endif
-	chipavail += size;
+	res = lookup_resource(&chipram_res, start);
+	if (!res) {
+		pr_err("amiga_chip_free: trying to free nonexistent region at "
+		       "%p\n", ptr);
+		return;
+	}
+
+	size = resource_size(res);
+	pr_debug("amiga_chip_free: free %lu bytes at %p\n", size, ptr);
+	atomic_add(size, &chipavail);
+	release_resource(res);
 	kfree(res);
-	return;
-    }
-    printk("amiga_chip_free: trying to free nonexistent region at %p\n", ptr);
 }
 EXPORT_SYMBOL(amiga_chip_free);
 
 
 unsigned long amiga_chip_avail(void)
 {
-#ifdef DEBUG
-	printk("amiga_chip_avail : %ld bytes\n", chipavail);
-#endif
-	return chipavail;
+	unsigned long n = atomic_read(&chipavail);
+
+	pr_debug("amiga_chip_avail : %lu bytes\n", n);
+	return n;
 }
 EXPORT_SYMBOL(amiga_chip_avail);
 
